/*
 *
 * Creating my own brush using mouse movement
 *
 
 @todo: rotate square
 
 
*/

int n = 50;
float noiseScale = 0.4;
float a = 20.0;
float alphaStep = 10.0;
PVector now = new PVector(0.0, 0.0);
PVector prev = new PVector(0.0, 0.0);
float radiusScale = 60.0;
float radiusD;
int c = 100;
boolean save = false;

boolean showColor = true;

PImage img;

float noiseVal;

ArrayList<PVector> alist = new ArrayList<PVector>();

void setup() {
  size(800, 600);
  colorMode(HSB, 360, 100, 100);
  background(#00000c);
  
  noStroke();
  
  radiusD = radiusScale;
}

void draw() {
  
  if (mousePressed == true) {
     
    alist.clear();
    
    for (int i = 0; i < n; i++) {
      //float size = random(5,15);
      float deltax = sin(i) * random(1, radiusD);
      float deltay = sin(i) * random(1, radiusD);
      noiseVal = noise(mouseX, noiseScale);
      
      fill(noiseVal * 100 + c, 100, 100, a);
      
      //ellipse(mouseX + deltax, mouseY + deltay, size, size);
      alist.add(new PVector(mouseX + deltax, mouseY + deltay));
    }
    
    noiseScale += 0.3;
    
    pushMatrix();
    translate(mouseX, mouseY);
    rotate(frameCount/5.0 * radians(10));
    
    drawList(alist, -mouseX, -mouseY);
    
    popMatrix();
  
  }
  
  if (showColor) {
    fill(noiseVal * 100 + c, 100, 100, a);
    rect(0, 0, 50, 50);
  } else {
    fill(0, 10, 10);
    rect(0, 0, 50, 50);
  }
  
  if (save) {
    if (frameCount % 20 == 0) {
      saveFrame("gen-####.png");
    }
  }
  
}

void drawList(ArrayList alist, float correctionX, float correctionY) {
  
  for (int i = 0; i < alist.size(); i++) {
    float size = random(5,15);
    ellipse(((PVector)alist.get(i)).x + correctionX, ((PVector)alist.get(i)).y + correctionY, size, size);
  }
  
}

void keyPressed() {
  if (key == 's') saveFrame("gen-####.png");
  if (key == 'c') showColor = !showColor;
  if (key == 'e') background(0, 10, 10);
  if (keyCode == UP) {
    a = (a + alphaStep);
    println(a);
  }
  if (keyCode == DOWN) {
    a = (a - alphaStep);
    println(a);
  }
  if (keyCode == LEFT) {
    c = (c - 10) % 360;
  }
  if (keyCode == RIGHT) {
    c = (c + 10) % 360;
  }
}